<?php
class Netzkollektiv_Lexoffice_Block_Adminhtml_System_Config_Auth_Button
    extends Mage_Adminhtml_Block_System_Config_Form_Field
{
    /*
     * Set template
     */
    protected function _construct()
    {
        parent::_construct();
        $this->setTemplate('lexoffice/auth/button.phtml');
    }

    public function getProfile() {
        try {
            return Mage::helper('lexoffice')->getApi()
                ->getProfile();
        } catch (Exception $e) {
            return array();
        }
    }

    public function getSubscriptionNote() {
        try {
            return Mage::helper('lexoffice')->getApi()
                ->getSubscription()->note;
        } catch (Exception $e) {
            return '';
        }
    }

    /**
     * Remove scope label
     *
     * @param  Varien_Data_Form_Element_Abstract $element
     * @return string
     */
    public function render(Varien_Data_Form_Element_Abstract $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Return element html
     *
     * @param  Varien_Data_Form_Element_Abstract $element
     * @return string
     */
    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {
        return $this->_toHtml();
    }

    /**
     * Generate synchronize button html
     *
     * @return string
     */
    public function getSubscribeButtonHtml()
    {
        $button = $this->getLayout()->createBlock('adminhtml/widget_button')
            ->setData(array(
                'id'        => 'lexoffice_authorize_button',
                'label'     => $this->helper('adminhtml')->__('Subscribe & Authorize'),
                'onclick'   => 'javascript:window.location.href=\''.$this->getUrl('*/lexoffice_auth/index').'\'; return false;'
            ));

        return $button->toHtml();
    }

    public function getCancelButtonHtml()
    {
        $button = $this->getLayout()->createBlock('adminhtml/widget_button')
            ->setData(array(
                'id'        => 'lexoffice_cancel_button',
                'label'     => $this->helper('adminhtml')->__('Cancel Subscription'),
                'onclick'   => 'javascript:window.location.href=\''.$this->getUrl('*/lexoffice_auth/cancel').'\'; return false;'
            ));

        return $button->toHtml();
    }
}
