<?php
abstract class Netzkollektiv_Lexoffice_Controller_Abstract extends Mage_Adminhtml_Controller_Action
{
    protected function _isAllowed() {
        return true;
    }

    public function indexAction()
    {
        $this->_title($this->__('lexoffice'))
            ->_title($this->__($this->_entityLabel));

        $this->loadLayout()
            ->_setActiveMenu('lexoffice/lexoffice')
            ->_addBreadcrumb($this->__('lexoffice'), $this->__('lexoffice'))
            ->_addBreadcrumb($this->__($this->_entityLabel),$this->__($this->_entityLabel))
            ->_addContent($this->getLayout()->createBlock($this->_entityBlock))
            ->renderLayout();
    }


    public function gridAction()
    {
        $this->getResponse()->setBody(
            $this->getLayout()->createBlock($this->_entityBlock.'_grid')->toHtml()
        );
    }

    public function syncAction() {
        $id = $this->getRequest()->getParam('id');
        
        try { 
            $this->_sync(array(
                (int)$id
            ));
        } catch (\Lexoffice\Lexception $e) { 
            $this->_redirect('*/lexoffice_auth/index');
            return false;
        } catch (Exception $e) {
            $this->_getSession()->addError($e->getMessage());
            $this->_redirect('*/*/index');
            return false;
        }
        $this->_getSession()->addSuccess($this->__('Document was transmitted succesfully'));
        $this->_redirect('*/*/index');
    }

    public function syncMassAction() {
        $prepareKey = $this->getRequest()->getParam('massaction_prepare_key');
        $ids = $this->getRequest()->getParam($prepareKey);

        try{
            $this->_sync($ids);
        } catch (\Lexoffice\Lexception $e) { 
            $this->_redirect('*/lexoffice_auth/index');
            return false;
        } catch (Exception $e) {
            $this->_getSession()->addError(nl2br($e->getMessage()));
            $this->_redirect('*/*/index');
            return false;
        }
        $this->_getSession()->addSuccess($this->__('Documents were transmitted succesfully'));
        $this->_redirect('*/*/index');
    }

    abstract protected function _sync($ids);

    protected function _getSession() {
        return Mage::getSingleton('adminhtml/session');
    }
}
