<?php
class Netzkollektiv_Lexoffice_Model_Observer {
    public function controllerFrontInitBefore( $event ) {
        spl_autoload_register( array($this, 'load'), true, true );
    }

    public static function load( $class )
    {
        if ( preg_match( '#^(Lexoffice\\\\.+?)\b#', $class ) ) {
            $phpFile = Mage::getBaseDir('lib') . '/' . str_replace( '\\', '/', $class ) . '.php';
            require_once( $phpFile );
        }
    }

    public function onInvoiceCreate($observer) {

        if (!Mage::getStoreConfig('lexoffice/invoices/auto_sync')) {
            return false;
        }

        $document = $observer->getEvent()->getInvoice();
        if ($document->getUpdatedAt() == $document->getCreatedAt()) {

            try { 
                Mage::getModel('lexoffice/sync')
                    ->setDocuments(array($document))
                    ->setPdfRenderer(Mage::getModel('sales/order_pdf_invoice'))
                    ->sync();
            } catch (Exception $e) {
                Mage::logException($e);
            }
        }
    }

    public function onCreditmemoCreate($observer) {

        if (!Mage::getStoreConfig('lexoffice/creditmemos/auto_sync')) {
            return false;
        }

        $document = $observer->getEvent()->getCreditmemo();
        if ($document->getUpdatedAt() == $document->getCreatedAt()) {

            try {
                Mage::getModel('lexoffice/sync')
                    ->setDocuments(array($document))
                    ->setPdfRenderer(Mage::getModel('sales/order_pdf_creditmemo'))
                    ->sync();
            } catch (Exception $e) {
                Mage::logException($e);
            }
        }
    }
}
