<?php
require_once Mage::getBaseDir('lib').'/Lexoffice/Api.php';
require_once Mage::getBaseDir('lib').'/Lexoffice/TokenException.php';

class Netzkollektiv_Lexoffice_Lexoffice_AuthController extends Mage_Adminhtml_Controller_Action {

    protected function _isAllowed() {
        return true;
    }

    protected function _getApi() {
        return Mage::helper('lexoffice')->getApi();
    }

    public function indexAction() {

        $this->_setBeforeAuthUrl();

        $redirectUri = $this->_getApi()
            ->getAuthUrl($this->getUrl('*/*/return'));
        $this->_redir($redirectUri);
    }

    public function returnAction() {
        $code = $this->getRequest()->getParam('code');
        $subscriptionId = $this->getRequest()->getParam('subscription_id'); 

        try { 
            $result = $this->_getApi()
                ->setToken((object) array('subscription_id' => $subscriptionId))
                ->getAccessToken($code);
            $result->subscription_id = $subscriptionId;
            Mage::helper('lexoffice')->saveToken($result);
        
            $this->_getSession()->addSuccess($this->__("You are now succesfully authenticated with lexoffice. Please try again!")); 

            $this->_redir(
                $this->_getSession()->getLexofficeBeforeAuthUrl()
            );
        } catch (\Lexoffice\Lexception $e) {
            $this->_redirect('*/lexoffice_auth/index');
            return false;
        } catch (Exception $e) {
            $this->_getSession()->addError($e->getMessage());
            $this->_redirect('*/*/index');
            return false;
        }
    }

    public function cancelAction() {
        try {
            Mage::helper('lexoffice')->getApi()
                ->cancelSubscription();

            Mage::getConfig()
                ->saveConfig('lexoffice/subscription/subscription_id', null)
                ->cleanCache();
        } catch (Exception $e) {}

        $this->_redirectReferer();
    }

    protected function _setBeforeAuthUrl() {
        $refererUrl = $this->_getRefererUrl();
        if (empty($refererUrl)) {
            $refererUrl = Mage::getBaseUrl();
        }
        $this->_getSession()->setLexofficeBeforeAuthUrl($refererUrl);
    }

    protected function _redir($uri) {
        Mage::app()
            ->getFrontController()
            ->getResponse()
            ->setRedirect($uri)
            ->sendResponse();
    }

    protected function _getSession() {
        return Mage::getSingleton('adminhtml/session');
    }
}
