<?php
$installer = $this;
$installer->startSetup();

$attributeCode = 'lexoffice_contact_id';

$installer->addAttribute('customer', $attributeCode,  array(
    'type'     => 'varchar',
    'backend'  => '',
    'label'    => 'lexoffice Contact Id',
    'input'    => 'text',
    'source'   => '',
    'visible'  => true,
    'required' => false,
    'default'  => '',
    'frontend' => '',
    'unique'   => true,
    'note'     => 'lexoffice Contact Id'
));

$setup = new Mage_Eav_Model_Entity_Setup('core_setup');

$entityTypeId     = $setup->getEntityTypeId('customer');
$attributeSetId   = $setup->getDefaultAttributeSetId($entityTypeId);
$attributeGroupId = $setup->getDefaultAttributeGroupId($entityTypeId, $attributeSetId);

$setup->addAttributeToGroup(
    $entityTypeId,
    $attributeSetId,
    $attributeGroupId,
    'lexoffice_contact_id',
    '100'
);

Mage::getSingleton('eav/config')
    ->getAttribute('customer', $attributeCode)
    ->setData('used_in_forms', array('adminhtml_customer'))
    ->setData('is_system', 0)
    ->setData('is_user_defined', 1)
    ->setData('is_visible', 1)
    ->setData('sort_order', 100)
    ->save();

$installer->getConnection()
    ->addColumn($installer->getTable('sales/invoice'),'lexoffice_sent', array(
        'type'      => Varien_Db_Ddl_Table::TYPE_INTEGER,
        'nullable'  => false,
        'length'    => 1,
        'after'     => null,
        'comment'   => 'Document was sent to Lexoffice'
    ));
$installer->getConnection()
    ->addColumn($installer->getTable('sales/invoice_grid'),'lexoffice_sent', array(
        'type'      => Varien_Db_Ddl_Table::TYPE_INTEGER,
        'nullable'  => false,
        'length'    => 1,
        'after'     => null,
        'comment'   => 'Document was sent to Lexoffice'
    ));
$installer->getConnection()
    ->addColumn($installer->getTable('sales/creditmemo'),'lexoffice_sent', array(
        'type'      => Varien_Db_Ddl_Table::TYPE_INTEGER,
        'nullable'  => false,
        'length'    => 1,
        'after'     => null,
        'comment'   => 'Document was sent to Lexoffice'
    )); 
$installer->getConnection()
    ->addColumn($installer->getTable('sales/creditmemo_grid'),'lexoffice_sent', array(
        'type'      => Varien_Db_Ddl_Table::TYPE_INTEGER,
        'nullable'  => false,
        'length'    => 1,
        'after'     => null,
        'comment'   => 'Document was sent to Lexoffice'
    ));

$installer->endSetup();
